import { system, ItemStack, ItemTypes } from "@minecraft/server";

export const timeline = {
    "start_scene": (player) => cutscene(player, [37, 113, -26], [8, 113, -23], 200, [29, 85, 21], true),
    "scene_2": (player) => cutscene(player, [-59, 101, -27], [-75, 89, -19], 200, [-78, 88, -51], true),
    "scene_3": (player) => cutscene(player, [70, 73, 82], [73, 80, 89], 180, [88, 72, 78], true),
    "scene_4": (player) => cutscene(player, [91, 81,126], [105, 81, 120], 200, [108, 81, 118], true),
    "scene_5": (player) => cutscene(player, [123, 79, 126], [141, 79, 104], 200, [158, 72, 135], true),
    "scene_6": (player) => cutscene(player, [-16, 79, 4], [-39, 79, -12], 180, [-50, 76, 32], false)
};
let ongoing_scene = 1;

export function lerp(start, end, t) {
    return start + t * (end - start);
}

export function cutscene(player, start_location, end_location, time, facing, transition = false) {
    let x = start_location[0];
    let y = start_location[1];
    let z = start_location[2];
    let a = end_location[0];
    let b = end_location[1];
    let c = end_location[2];
    let x_diff, y_diff, z_diff;
    if (ongoing_scene == 1) {
        player.runCommand("camera @s fade time 1 5 1");
        system.runTimeout(() => {
            player.runCommand("title @s subtitle §8A Festive Fun Map -By §f§lL§r§fimestone§r");
            player.runCommand("title @s title §l§cW§r§cinter §l§fW§r§fonderland§r");
            system.runTimeout(() => {
                player.playSound("cinematic_intro");
                player.sendMessage("§8§l> §r§fIn India, Christmas is a vibrant spectacle, where diverse traditions and a kaleidoscope of festive colors come together in a beautiful tapestry. §a§l[1/6]§r");
                system.runTimeout(() => {
                    player.sendMessage("§8§l> §r§fPicture streets adorned with dazzling lights, and churches resonating with the soulful tunes of carols--a lively celebration that reflects the rich cultural mosaic of the country. §a§l[2/6]§r");
                    system.runTimeout(() => {
                        player.sendMessage("§8§l> §r§fNow, imagine this festive spirit taking on an extra flair in Goa, a coastal state known for its unique blend of traditional warmth and modern charm. §a§l[3/6]§r");
                        system.runTimeout(() => {
                            player.sendMessage("§8§l> §r§fHere, Christmas embraces not only the traditional customs but also the glitzy allure of renowned casinos. §a§l[4/6]§r");
                            system.runTimeout(() => {
                                player.sendMessage("§8§l> §r§fAs night falls, these establishments light up with a dazzling display, infusing the holiday with an extra touch of glamour. §a§l[5/6]§r");
                                system.runTimeout(() => {
                                    player.sendMessage("§8§l> §r§fFrom sacred ceremonies to the lively energy of Goa's vibrant casinos, Christmas in India unfolds as a magical journey, inviting everyone to partake in the universal themes of love and goodwill. §a§l[6/6]§r");
                                }, 160);
                            }, 160);
                        }, 180);
                    }, 240);
                }, 220);
            }, 80);
        }, 20);
    }
    system.runTimeout(() => {
        player.runCommand("gamemode spectator @s");
        ongoing_scene += 1;
    }, 20);
    system.runTimeout(() => {
        player.runCommand(`tp @s ${start_location[0]} ${start_location[1]} ${start_location[2]}`);
        let i = 0;
        let id = system.runInterval(() => {
            i += 1;
            let t = i / (time - 30);

            x_diff = lerp(x, a, t);
            y_diff = lerp(y, b, t);
            z_diff = lerp(z, c, t);

            player.runCommand(`tp @s ${x_diff} ${y_diff} ${z_diff} facing ${facing[0]} ${facing[1]} ${facing[2]}`);

            if (i === (time - 30)) {
                player.runCommand("camera @s fade time 1 2 1");
                if (transition) {
                    timeline[`scene_${ongoing_scene}`](player);
                }
                else {
                    system.runTimeout(() => {
                        player.runCommand("gamemode adventure @s");
                        player.runCommand("setblock 29 60 21 redstone_block");
                        player.runCommand("setblock 87 52 100 redstone_block");
                        player.runCommand("setblock -46 54 0 redstone_block");
                        system.runTimeout(()=>{
                            player.runCommand("setblock 29 60 21 air");
                            player.runCommand("setblock 87 52 100 air");
                            player.runCommand("setblock -46 54 0 air");
                        },40);
                        let map = new ItemStack(ItemTypes.get("ww:map_menu"), 1);
                        let bells = new ItemStack(ItemTypes.get("ww:bell"), 64);

                        map.setLore(["§c§lRight Click to open§r", "- Use this guide book to visit games in the map"]);

                        let inv = player.getComponent("inventory").container;
                        inv.setItem(0, map);
                        inv.setItem(1, bells);

                        player.runCommand("tp @s 40 72 45 facing 40 72 41");
                    }, 60);
                }
            } else if (i === time) {
                system.clearRun(id);
            }
        }, 1);
    }, 60);
}

